SCREEN 12
TIMER ON
COLOR 3
LOCATE 2, 12
PRINT "           Motion of one charged corpuscle (OMC)"
LOCATE 4, 12
PRINT "    in a magnetic field (MF) such as a  Magnetic; Cocoon,"
LOCATE 6, 12
PRINT "which is created by two others mobile charged corpuscles (TMC)"
LOCATE 8, 25
PRINT "Etmc = 5 eV;    Eomc = 50 eV"
ON TIMER(5) GOSUB 1
DO WHILE INKEY$ = "": LOOP

1
CLS
C$ = "  +#.#####^^^^"
Pi = 3.141593
Mo = 4 * Pi * .0000001
K = Mo / (4 * Pi)       'SI
M = 1.67E-27 * 2        '[kg]
Q = 1.6E-19             '[C]

LOCATE 6, 2
COLOR 9
INPUT "distance between TMC [sm](10 - 50)="; A0
a = A0 * .01    '[m] distance between TMC
Xk1 = 0
Yk1 = 0
Xk2 = Xk1 + a
Yk2 = 0
CIRCLE (Xk1 * 1000 + 50, Yk1 + 240), 10, 9
CIRCLE (Xk2 * 1000 + 50, Yk2 + 240), 10, 9
Ek = 5          '[eV] energy of TMC
TVk = 0         'angle of moving of TMC
Vk = SQR(2 * Ek * ABS(Q) / M)      'velocity of TMC
Vkx = Vk * COS(TVk)
Vky = 0
Vkz = 0
LOCATE 1, 60
PRINT "V tmc ="; USING C$; Vk

COLOR 13
Eq = 50        '[eV] energy of entry of OMC
LOCATE 8, 2
INPUT "angle of entry of OMC (0 - 360)="; TVq
Vq = SQR(2 * Eq * ABS(Q) / M)      'velocity of OMC
Vqx = Vq * COS(TVq)
Vqy = Vq * SIN(TVq)
Vqz = 0
LOCATE 3, 60
PRINT "V omc ="; USING C$; Vq
dlq = .0001#                   'step of moving of OMC
Xq = Xk1 + .5 * a              'coordinate began movements of OMC
LOCATE 10, 2
INPUT "Coordinate Y began movements of OMC [sm](-25/+25)="; Yq0
COLOR 8
Yq = Yq0 * .01
Zq = 0

Fx = 0
Fy = 0
Fz = 0
FOR t = 0 TO 100000
dt = dlq / Vq
        Rx1 = Xq - Xk1
        Rx2 = Xq - Xk2
       
        Ry1 = Yq - Yk1
        Ry2 = Yq - Yk2          'Rz1 = 0    Rz2 = 0

        R1 = SQR(Rx1 * Rx1 + Ry1 * Ry1)
        R2 = SQR(Rx2 * Rx2 + Ry2 * Ry2)
              
'B = K * Q * [V x R] / R^3  MF, created by TMC [Tl]
'1
'Bx1 = K * Q * (Vky * Rz1 - Ry1 * Vkz) / R1 ^ 3    == 0
'By1 = K * Q * (Vkz * Rx1 - Rz1 * Vkx) / R1 ^ 3    == 0
Bz1 = K * Q * (Vkx * Ry1 - Rx1 * Vky) / R1 ^ 3

'2
'Bx2 = K * Q * (Vky * Rz2 - Ry2 * Vkz) / R2 ^ 3    == 0
'By2 = K * Q * (Vkz * Rx2 - Rz2 * Vkx) / R2 ^ 3    == 0
Bz2 = K * Q * (Vkx * Ry2 - Rx2 * Vky) / R2 ^ 3

'Lorentz force which influence on OMC        FL = Q*[V x B]
                'Px = (Vy * (Hz1 + Hz2) - (Hy1 + Hy2) * Vz)
                'Py = (Vz * (Hx1 + Hx2) - (Hz1 + Hz2) * Vx)
                'Pz = (Vx * (Hy1 + Hy2) - (Hx1 + Hx2) * Vy)

Fx = Vqy * (Bz1 + Bz2)
Fy = -(Bz1 + Bz2) * Vqx
'Fz = (Vqx * (By1 + By2) - (Bx1 + Bx2) * Vqy)  ==0

'F = M*dV/dt = FL = Q*[V x Bk]  ==>  dV=PX*dt/M

        dVqx = Fx * dt / M
        dVqy = Fy * dt / M
        dVqz = 0                                'dVz = Fz * dt / M
          Vqxt = Vqx + dVqx
          Vqyt = Vqy + dVqy
          Vqzt = 0                              'Vqzt = Vqz + dVqz
          Vqt = SQR(Vqxt ^ 2 + Vqyt ^ 2)        '+ Vqzt ^ 2)
          kV = Vq / Vqt
'kV - because velocity of OMC must be constant
        Vqx = Vqxt * kV
        Vqy = Vqyt * kV
        Vqz = 0                         'Vqz = Vqzt * kV
        V = SQR(Vqx ^ 2 + Vqy ^ 2)      '+ Vqz ^ 2)
        dXq = Vqx * dt
        dYq = Vqy * dt
        dZq = 0                         'dZq = Vz * dt
          Xq = Xq + dXq
          Yq = Yq + dYq
          Zq = 0                        'Zq = Zq + dZq
     PSET (Xq * 1000 + 50, Yq * 1000 + 240), 13
     NEXT t
END


